/*
	asc2htm.c: converte da ASCII a HTML
*/

#include <stdio.h>
#include <string.h>
#define USCITA	"noname.htm"

unsigned char *vets[256] =
{
	'\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0',
	"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",
	"\n", "\0", "\f", "\r", '\0', '\0', '\0', '\0', '\0', '\0',
	'\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0',
	'\0', "\0", " ", "!", "\"", "#", "$", "%", "&amp", "'", "(",
	")", "*", "+", ",", "-", ".", "/", "0", "1", "2",
	"3", "4", "5", "6", "7", "8", "9", ":", ";", "<",
	"=", ">", "?", "@", "A", "B", "C", "D", "E", "F",
	"G", "H", "I", "J", "K", "L", "M", "N", "O", "P",
	"Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z",
	"[", "\\", "]", "^", "_", "`", "a", "b", "c", "d",
	"e", "f", "g", "h", "i", "j", "k", "l", "m", "n",
	"o", "p", "q", "r", "s", "t", "u", "v", "w", "x",
	"y", "z", "{", "|", "}", "~", "^?", "&Ccedil", "&uuml",
	"&eacute", "&acirc", "&auml", "&agrave",
	"&aring", "&ccedil", "&ecirc", "&euml",
	"&egrave", "&iuml", "&icirc", "&igrave",
	"&Auml", "&Aring", "&Eacute", "&aelig",
	"&AElig", "&ocirc", "&ouml", "&ograve",
	"&ucirc", "&ugrave", "&yuml", "&Ouml",
	"&Uuml", "&cslash", "f", "Y",
	"Pt", "f", "&aacute", "&iacute",
	"&oacute", "&uacute", "&ntilde", "&Ntilde",
	"&#170", "&#186", "?", "+", "+",
	"1/2", "1/4", "!", "\"", "\"", "#", "#", "#",
	"|", "+", "+", "+", "+", "+", "+", "|", "+", "+",
	"+", "+", "+", "+", "+", "+", "+", "-", "+", "+", "+", "+",
	"+", "+", "+", "+", "-", "+", "+", "+", "+", "+",
	"+", "+", "+", "+", "+", "+", "+", "+", "#", "#",
	"#", "#", "#", "a", "&szlig", ".", ".", ".", ".", ".",
	".", ".", ".", ".", ".", ".", "&oslash", ".", ".", ".",
	".", ".", ".", ".", ".", ".", ".", ".", ".", ".",
	".", ".", ".", ".", "."
};

void copia(FILE *fi, FILE *fo)  /* copia i files */
{
	int c;

	while ((c = getc(fi)) != EOF)
	{
			fputs(vets[c], fo);
	}
}

int main(int argc, char *argv[])
{
	FILE *fi, *fo;
	short int lung = 0, error = 0;
	unsigned char c, i;
	char nomefile[16], uscita[16];
	unsigned char *fmt0 = "asc2htm: non posso aprire %s\n";

#ifdef TEST
	system("tput mc5");
	for (i=0; i<255; i++)
		printf("char %d = %s\n", i, vets[i]);
	system("tput mc4");
#endif
	if (argc<2 || argc>3)
	{
		printf("uso: asc2htm fileascii [filehtml]\n");
		exit(1);
	}
	strcpy(nomefile, argv[1]);
	if (argc == 2)
		strcpy(uscita, USCITA);
	else
		strcpy(uscita, argv[2]);
	if (fi = fopen(nomefile, "r"))
	{
		if (fo = fopen(uscita, "w"))
		{
			fprintf(fo,"<HTML>\n");
			fprintf(fo,"<HEAD><TITLE>%s</TITLE></HEAD>\n",uscita);
			fprintf(fo,"<BODY>\n");
			fprintf(fo,"<PRE>\n");
			copia(fi,fo);
			fprintf(fo,"</PRE>\n");
			fprintf(fo,"\n</BODY>\n</HTML>\n");
			fclose(fo);
		}
		else
			printf(fmt0, uscita);
		fclose(fi);
	}
	else
		printf(fmt0, nomefile);
}
