/*
	no_wrap.c
	elimina i CR e LF che servono a fare il margine destro.
	ritorna 0 se  stato richiamato senza argomenti,
	-1 in caso di errore, 1 se ha funzionato.
*/

#include <stdio.h>
#define CR	13
#define LF	10
#define DOT	46
#define COLON	58
#define S_COLON	59

int main(int argc, char *argv[])
{
	FILE *fi, *fo;
	int c, status = 0;

	if (argc != 3)
	{
		printf("uso: no_wrap file.in file.out\n");
		return(status);
	}
	if (fi = fopen(argv[1], "r"))
	{
		if (fo = fopen(argv[2], "w"))
		{
			while ((c = fgetc(fi)) != EOF)
			{
				switch(c)
				{
				case CR:
				case LF:
					break;
				case DOT:
				case COLON:
				case S_COLON:
					fputc(c,fo);
					c = fgetc(fi);
					fputc(c,fo);
					c = fgetc(fi);
					fputc(c,fo);
					break;
				default:
					fputc(c,fo);
					break;
				}
			}
			status = 1;
		}
		else
		{
			printf("no_wrap: non posso aprire %s (W)\n",argv[2]);
			status = -1;
		}
	}
	else
	{
		printf("no_wrap: non posso aprire %s (R)\n",argv[1]);
		status = -1;
	}
	return(status);
}
